scala.collection.mutable

# ArrayStack

#### class ArrayStack[T] extends Seq[T] with SeqLike[T, ArrayStack[T]] with GenericTraversableTemplate[T, ArrayStack] with Cloneable[ArrayStack[T]] with Builder[T, ArrayStack[T]] with Serializable

Simple stack class backed by an array. Should be significantly faster than the standard mutable stack.

T

  type of the elements contained in this array stack.

Annotations
  @cloneable() @SerialVersionUID( uid = 8565219180626620510L )
Source
  ArrayStack.scala
Since

  2.7

See also

  "Scala's Collection Library overview" section on `Array Stacks` for more information.

Linear Supertypes
Serializable, Serializable, Builder[T, ArrayStack[T]], Growable[T], Seq[T], SeqLike[T, ArrayStack[T]], Cloneable[ArrayStack[T]], Seq[T], SeqLike[T, ArrayStack[T]], GenSeq[T], GenSeqLike[T, ArrayStack[T]], PartialFunction[Int, T], (Int) ⇒ T, Iterable[T], Iterable[T], IterableLike[T, ArrayStack[T]], Equals, GenIterable[T], GenIterableLike[T, ArrayStack[T]], Traversable[T], Mutable, Traversable[T], GenTraversable[T], GenericTraversableTemplate[T, ArrayStack], TraversableLike[T, ArrayStack[T]], GenTraversableLike[T, ArrayStack[T]], Parallelizable[T, ParSeq[T]], TraversableOnce[T], GenTraversableOnce[T], FilterMonadic[T, ArrayStack[T]], HasNewBuilder[T, ArrayStack[T]], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ArrayStack
2. Serializable
3. Serializable
4. Builder
5. Growable
6. Seq
7. SeqLike
8. Cloneable
9. Seq
10. SeqLike
11. GenSeq
12. GenSeqLike
13. PartialFunction
14. Function1
15. Iterable
16. Iterable
17. IterableLike
18. Equals
19. GenIterable
20. GenIterableLike
21. Traversable
22. Mutable
23. Traversable
24. GenTraversable
25. GenericTraversableTemplate
26. TraversableLike
27. GenTraversableLike
28. Parallelizable
29. TraversableOnce
30. GenTraversableOnce
31. FilterMonadic
32. HasNewBuilder
33. AnyRef
34. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ArrayStack()

### Type Members

1. #### type Self = ArrayStack[T]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): ArrayStack[B]

   [use case] Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the array stack is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: T, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

   Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the array stack is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

6. #### def ++:[B >: T, That](that: Traversable[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new array stack which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): ArrayStack[B]

   [use case] Concatenates this array stack with the elements of a traversable collection.

   [use case]

   Concatenates this array stack with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: T, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

   Concatenates this array stack with the elements of a traversable collection.

   Concatenates this array stack with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### def ++=(xs: TraversableOnce[T]): ArrayStack.this.type

   Pushes all the provided elements in the traversable object onto the stack.

   Pushes all the provided elements in the traversable object onto the stack.

   returns

     A reference to this stack.

   Definition Classes
     ArrayStack → Growable

10. #### abstract def +:(elem: T): ArrayStack[T]

    [use case] A copy of the array stack with an element prepended.

    [use case]

    A copy of the array stack with an element prepended.

    elem

      the prepended element

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this array stack.

    Definition Classes
      GenSeqLike

11. #### def +:[B >: T, That](elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

    A copy of the array stack with an element prepended.

    A copy of the array stack with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original array stack is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned array stack.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this array stack.

    Definition Classes
      SeqLike → GenSeqLike

12. #### def +=(x: T): ArrayStack.this.type

    Does the same as `push`, but returns the updated stack.

    Does the same as `push`, but returns the updated stack.

    x

      The element to push.

    returns

      A reference to this stack.

    Definition Classes
      ArrayStack → Builder → Growable

13. #### def +=(elem1: T, elem2: T, elems: T*): ArrayStack.this.type

    adds two or more elements to this array stack.

    adds two or more elements to this array stack.

    elem1

      the first element to add.

    elem2

      the second element to add.

    elems

      the remaining elements to add.

    returns

      the array stack itself

    Definition Classes
      Growable

14. #### def /:[B](z: B)(op: (B, T) ⇒ B): B

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

15. #### def /:\[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

16. #### abstract def :+(elem: T): ArrayStack[T]

    [use case] A copy of this array stack with an element appended.

    [use case]

    A copy of this array stack with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this array stack followed by `elem`.

    Definition Classes
      GenSeqLike

17. #### def :+[B >: T, That](elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

    A copy of this array stack with an element appended.

    A copy of this array stack with an element appended.

    B

      the element type of the returned array stack.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of all elements of this array stack followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike

18. #### def :\[B](z: B)(op: (T, B) ⇒ B): B

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this array stack, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

19. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

21. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this array stack to a string builder.

    Appends all elements of this array stack to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this array stack without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

22. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this array stack to a string builder using a separator string.

    Appends all elements of this array stack to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this array stack, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

23. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this array stack to a string builder using start, end, and separator strings.

    Appends all elements of this array stack to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

24. #### def aggregate[B](z: B)(seqop: (B, T) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

25. #### def andThen[C](k: (T) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

26. #### def apply(n: Int): T

    Retrieve n'th element from stack, where top of stack has index 0.

    Retrieve n'th element from stack, where top of stack has index 0.

    This is a constant time operation.

    n

      the index of the element to return

    returns

      the element at the specified index

    Definition Classes
      ArrayStack → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      IndexOutOfBoundsException

      if the index is out of bounds

27. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

28. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this array stack should be compared

    returns

      `true`, if this array stack can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

29. #### def clear(): Unit

    Empties the stack.

    Empties the stack.

    Definition Classes
      ArrayStack → Builder → Growable

30. #### def clone(): ArrayStack[T]

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Definition Classes
      ArrayStack → Cloneable → AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### abstract def collect[B](pf: PartialFunction[T, B]): ArrayStack[B]

    [use case] Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the array stack.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

32. #### def collect[B, That](pf: PartialFunction[T, B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

    Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the array stack.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

33. #### def collectFirst[B](pf: PartialFunction[T, B]): Option[B]

    Finds the first element of the array stack for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the array stack for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

34. #### def combinations(n: Int): Iterator[ArrayStack[T]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this array stack.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

35. #### def combine(f: (T, T) ⇒ T): Unit

    Pop the top two elements off the stack, apply `f` to them and push the result back on to the stack.

    Pop the top two elements off the stack, apply `f` to them and push the result back on to the stack.

    This function will throw an exception if stack contains fewer than 2 elements.

    f

      The function to apply to the top two elements.

36. #### def companion: scala.collection.mutable.ArrayStack.type

    The factory companion object that builds instances of class ArrayStack.

    The factory companion object that builds instances of class ArrayStack. (or its `Iterable` superclass where class ArrayStack is not a `Seq`.)

    Definition Classes
      ArrayStack → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

37. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ T

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

38. #### def contains(elem: Any): Boolean

    Tests whether this array stack contains a given value as an element.

    Tests whether this array stack contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this array stack has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

39. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this array stack contains a given sequence as a slice.

    Tests whether this array stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this array stack contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

40. #### abstract def copyToArray(xs: Array[T], start: Int, len: Int): Unit

    [use case] Copies elements of this array stack to an array.

    [use case]

    Copies elements of this array stack to an array. Fills the given array `xs` with at most `len` elements of this array stack, starting at position `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

41. #### def copyToArray[B >: T](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this array stack to an array.

    Copies elements of this array stack to an array. Fills the given array `xs` with at most `len` elements of this array stack, starting at position `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

42. #### abstract def copyToArray(xs: Array[T]): Unit

    [use case] Copies values of this array stack to an array.

    [use case]

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

43. #### def copyToArray[B >: T](xs: Array[B]): Unit

    Copies values of this array stack to an array.

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

44. #### abstract def copyToArray(xs: Array[T], start: Int): Unit

    [use case] Copies values of this array stack to an array.

    [use case]

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack, beginning at index `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

45. #### def copyToArray[B >: T](xs: Array[B], start: Int): Unit

    Copies values of this array stack to an array.

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack, beginning at index `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

46. #### def copyToBuffer[B >: T](dest: Buffer[B]): Unit

    Copies all elements of this array stack to a buffer.

    Copies all elements of this array stack to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

47. #### def corresponds[B](that: GenSeq[B])(p: (T, B) ⇒ Boolean): Boolean

    Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this array stack and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

48. #### def count(p: (T) ⇒ Boolean): Int

    Counts the number of elements in the array stack which satisfy a predicate.

    Counts the number of elements in the array stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

49. #### abstract def diff(that: Seq[T]): ArrayStack[T]

    [use case] Computes the multiset difference between this array stack and another sequence.

    [use case]

    Computes the multiset difference between this array stack and another sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this array stack except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

50. #### def diff[B >: T](that: GenSeq[B]): ArrayStack[T]

    Computes the multiset difference between this array stack and another sequence.

    Computes the multiset difference between this array stack and another sequence.

    B

      the element type of the returned array stack.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this array stack except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike

51. #### def distinct: ArrayStack[T]

    Builds a new array stack from this array stack without any duplicate elements.

    Builds a new array stack from this array stack without any duplicate elements.

    returns

      A new array stack which contains the first occurrence of every element of this array stack.

    Definition Classes
      SeqLike → GenSeqLike

52. #### def drain(f: (T) ⇒ Unit): Unit

    Empties the stack, passing all elements on it in LIFO order to the provided function.

    Empties the stack, passing all elements on it in LIFO order to the provided function.

    f

      The function to drain to.

53. #### def drop(n: Int): ArrayStack[T]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this array stack.

    returns

      a array stack consisting of all elements of this array stack except the first `n` ones, or else the empty array stack, if this array stack has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

54. #### def dropRight(n: Int): ArrayStack[T]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a array stack consisting of all elements of this array stack except the last `n` ones, or else the empty array stack, if this array stack has less than `n` elements.

    Definition Classes
      IterableLike

55. #### def dropWhile(p: (T) ⇒ Boolean): ArrayStack[T]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this array stack whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

56. #### def dup(): Unit

    Duplicate the top element of the stack.

    Duplicate the top element of the stack.

    After calling this method, the stack will have an additional element at the top equal to the element that was previously at the top. If the stack is empty, an exception is thrown.

57. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this array stack ends with the given sequence.

    Tests whether this array stack ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this array stack has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

58. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

59. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

60. #### def exists(p: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this array stack.

    Tests whether a predicate holds for some of the elements of this array stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this array stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

61. #### def filter(p: (T) ⇒ Boolean): ArrayStack[T]

    Selects all elements of this array stack which satisfy a predicate.

    Selects all elements of this array stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new array stack consisting of all elements of this array stack that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

62. #### def filterNot(p: (T) ⇒ Boolean): ArrayStack[T]

    Selects all elements of this array stack which do not satisfy a predicate.

    Selects all elements of this array stack which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new array stack consisting of all elements of this array stack that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

63. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

64. #### def find(p: (T) ⇒ Boolean): Option[T]

    Finds the first element of the array stack satisfying a predicate, if any.

    Finds the first element of the array stack satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the array stack that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

65. #### abstract def flatMap[B](f: (T) ⇒ GenTraversableOnce[B]): ArrayStack[B]

    [use case] Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this array stack and concatenating the results.

    Definition Classes
      GenTraversableLike

66. #### def flatMap[B, That](f: (T) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

    Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of array stack. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this array stack and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

67. #### abstract def flatten[B]: ArrayStack[B]

    [use case] Converts this array stack of traversable collections into a array stack formed by the elements of these traversable collections.

    [use case]

    Converts this array stack of traversable collections into a array stack formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new array stack resulting from concatenating all element array stacks.

    Definition Classes
      GenericTraversableTemplate

68. #### def fold[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this array stack using the specified associative binary operator.

    Folds the elements of this array stack using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

69. #### def foldLeft[B](z: B)(op: (B, T) ⇒ B): B

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

70. #### def foldRight[B](z: B)(op: (T, B) ⇒ B): B

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

71. #### def forall(p: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this array stack.

    Tests whether a predicate holds for all elements of this array stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this array stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

72. #### abstract def foreach(f: (T) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this array stack.

    [use case]

    Applies a function `f` to all elements of this array stack.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

73. #### def foreach[U](f: (T) ⇒ U): Unit

    Applies a function `f` to all elements of this array stack.

    Applies a function `f` to all elements of this array stack.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      ArrayStack → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

74. #### def genericBuilder[B]: Builder[B, ArrayStack[B]]

    The generic builder that builds instances of ArrayStack at arbitrary element types.

    The generic builder that builds instances of ArrayStack at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

75. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

76. #### def groupBy[K](f: (T) ⇒ K): Map[K, ArrayStack[T]]

    Partitions this array stack into a map of array stacks according to some discriminator function.

    Partitions this array stack into a map of array stacks according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new array stack.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to array stacks such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a array stack of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

77. #### def grouped(size: Int): Iterator[ArrayStack[T]]

    Partitions elements in fixed size array stacks.

    Partitions elements in fixed size array stacks.

    size

      the number of elements per group

    returns

      An iterator producing array stacks of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

78. #### def hasDefiniteSize: Boolean

    Tests whether this array stack is known to have a finite size.

    Tests whether this array stack is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

79. #### def hashCode(): Int

    Hashcodes for ArrayStack produce a value from the hashcodes of all the elements of the array stack.

    Hashcodes for ArrayStack produce a value from the hashcodes of all the elements of the array stack.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

80. #### def head: T

    Selects the first element of this array stack.

    Selects the first element of this array stack.

    returns

      the first element of this array stack.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the array stack is empty.

81. #### def headOption: Option[T]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this array stack if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

82. #### abstract def indexOf(elem: T, from: Int): Int

    [use case] Finds index of first occurrence of some value in this array stack after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this array stack after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

83. #### def indexOf[B >: T](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this array stack after or at some start index.

    Finds index of first occurrence of some value in this array stack after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

84. #### abstract def indexOf(elem: T): Int

    [use case] Finds index of first occurrence of some value in this array stack.

    [use case]

    Finds index of first occurrence of some value in this array stack.

    elem

      the element value to search for.

    returns

      the index of the first element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

85. #### def indexOf[B >: T](elem: B): Int

    Finds index of first occurrence of some value in this array stack.

    Finds index of first occurrence of some value in this array stack.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

86. #### def indexOfSlice[B >: T](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this array stack contains a given sequence as a slice.

    Finds first index after or at a start index where this array stack contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

87. #### def indexOfSlice[B >: T](that: GenSeq[B]): Int

    Finds first index where this array stack contains a given sequence as a slice.

    Finds first index where this array stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

88. #### def indexWhere(p: (T) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

89. #### def indexWhere(p: (T) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

90. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this array stack.

    Definition Classes
      SeqLike

91. #### def init: ArrayStack[T]

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a array stack consisting of all elements of this array stack except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the array stack is empty.

92. #### def inits: Iterator[ArrayStack[T]]

    Iterates over the inits of this array stack.

    Iterates over the inits of this array stack. The first value will be this array stack and the final one will be an empty array stack, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this array stack

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

93. #### abstract def intersect(that: Seq[T]): ArrayStack[T]

    [use case] Computes the multiset intersection between this array stack and another sequence.

    [use case]

    Computes the multiset intersection between this array stack and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this array stack which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike

94. #### def intersect[B >: T](that: GenSeq[B]): ArrayStack[T]

    Computes the multiset intersection between this array stack and another sequence.

    Computes the multiset intersection between this array stack and another sequence.

    B

      the element type of the returned array stack.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this array stack which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike

95. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this array stack contains given index.

    Tests whether this array stack contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this array stack contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

96. #### def isEmpty: Boolean

    Tests whether the array stack is empty.

    Tests whether the array stack is empty.

    returns

      `true` if the array stack contains no elements, `false` otherwise.

    Definition Classes
      ArrayStack → IterableLike → GenIterableLike → GenericTraversableTemplate → TraversableLike → TraversableOnce → GenTraversableOnce

97. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

98. #### final def isTraversableAgain: Boolean

    Tests whether this array stack can be repeatedly traversed.

    Tests whether this array stack can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

99. #### def iterator: Iterator[T]

    Creates and iterator over the stack in LIFO order.

    Creates and iterator over the stack in LIFO order.

    returns

      an iterator over the elements of the stack.

    Definition Classes
      ArrayStack → IterableLike → GenIterableLike

100. #### def last: T

     Selects the last element.

     Selects the last element.

     returns

       The last element of this array stack.

     Definition Classes
       TraversableLike
     Exceptions thrown
       NoSuchElementException

       If the array stack is empty.

101. #### abstract def lastIndexOf(elem: T, end: Int): Int

     [use case] Finds index of last occurrence of some value in this array stack before or at a given end index.

     [use case]

     Finds index of last occurrence of some value in this array stack before or at a given end index.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

102. #### def lastIndexOf[B >: T](elem: B, end: Int): Int

     Finds index of last occurrence of some value in this array stack before or at a given end index.

     Finds index of last occurrence of some value in this array stack before or at a given end index.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

103. #### abstract def lastIndexOf(elem: T): Int

     [use case] Finds index of last occurrence of some value in this array stack.

     [use case]

     Finds index of last occurrence of some value in this array stack.

     elem

       the element value to search for.

     returns

       the index of the last element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

104. #### def lastIndexOf[B >: T](elem: B): Int

     Finds index of last occurrence of some value in this array stack.

     Finds index of last occurrence of some value in this array stack.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     returns

       the index of the last element of this array stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

105. #### def lastIndexOfSlice[B >: T](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this array stack contains a given sequence as a slice.

     Finds last index before or at a given end index where this array stack contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

106. #### def lastIndexOfSlice[B >: T](that: GenSeq[B]): Int

     Finds last index where this array stack contains a given sequence as a slice.

     Finds last index where this array stack contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this array stack starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

107. #### def lastIndexWhere(p: (T) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqLike → GenSeqLike

108. #### def lastIndexWhere(p: (T) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

109. #### def lastOption: Option[T]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this array stack$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike

110. #### def length: Int

     The number of elements in the stack

     The number of elements in the stack

     returns

       the number of elements in this array stack.

     Definition Classes
       ArrayStack → SeqLike → GenSeqLike

111. #### def lengthCompare(len: Int): Int

     Compares the length of this array stack to a test value.

     Compares the length of this array stack to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

                  x <  0       if this.length <  len
                  x == 0       if this.length == len
                  x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqLike

112. #### def lift: (Int) ⇒ Option[T]

     Turns this partial function into an plain function returning an `Option` result.

     Turns this partial function into an plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

113. #### abstract def map[B](f: (T) ⇒ B): ArrayStack[B]

     [use case] Builds a new collection by applying a function to all elements of this array stack.

     [use case]

     Builds a new collection by applying a function to all elements of this array stack.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this array stack and collecting the results.

     Definition Classes
       GenTraversableLike

114. #### def map[B, That](f: (T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Builds a new collection by applying a function to all elements of this array stack.

     Builds a new collection by applying a function to all elements of this array stack.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this array stack and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic

115. #### def mapResult[NewTo](f: (ArrayStack[T]) ⇒ NewTo): Builder[T, NewTo]

     Creates a new builder by applying a transformation function to the results of this builder.

     Creates a new builder by applying a transformation function to the results of this builder.

     NewTo

       the type of collection returned by `f`.

     f

       the transformation function.

     returns

       a new builder which is the same as the current builder except that a transformation function is applied to this builder's result.

     Definition Classes
       Builder

116. #### abstract def max: T

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this array stack with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

117. #### def max[B >: T](implicit cmp: Ordering[B]): T

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this array stack with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

118. #### def maxBy[B](f: (T) ⇒ B)(implicit cmp: Ordering[B]): T

     Definition Classes
       TraversableOnce → GenTraversableOnce

119. #### abstract def min: T

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this array stack with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

120. #### def min[B >: T](implicit cmp: Ordering[B]): T

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this array stack with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

121. #### def minBy[B](f: (T) ⇒ B)(implicit cmp: Ordering[B]): T

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### def mkString: String

     Displays all elements of this array stack in a string.

     Displays all elements of this array stack in a string.

     returns

       a string representation of this array stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this array stack follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

123. #### def mkString(sep: String): String

     Displays all elements of this array stack in a string using a separator string.

     Displays all elements of this array stack in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this array stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

124. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this array stack in a string using start, end, and separator strings.

     Displays all elements of this array stack in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this array stack. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

125. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

126. #### def newBuilder: Builder[T, ArrayStack[T]]

     The builder that builds instances of type ArrayStack[A]

     The builder that builds instances of type ArrayStack[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

127. #### def nonEmpty: Boolean

     Tests whether the array stack is not empty.

     Tests whether the array stack is not empty.

     returns

       `true` if the array stack contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

128. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

129. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

130. #### def orElse[A1 <: Int, B1 >: T](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

131. #### abstract def padTo(len: Int, elem: T): ArrayStack[T]

     [use case] A copy of this array stack with an element value appended until a given target length is reached.

     [use case]

     A copy of this array stack with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this array stack followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

132. #### def padTo[B >: T, That](len: Int, elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     A copy of this array stack with an element value appended until a given target length is reached.

     A copy of this array stack with an element value appended until a given target length is reached.

     B

       the element type of the returned array stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` consisting of all elements of this array stack followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike

133. #### def par: ParSeq[T]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

134. #### def parCombiner: Combiner[T, ParSeq[T]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → SeqLike → TraversableLike → Parallelizable

135. #### def partition(p: (T) ⇒ Boolean): (ArrayStack[T], ArrayStack[T])

     Partitions this array stack in two array stacks according to a predicate.

     Partitions this array stack in two array stacks according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of array stacks: the first array stack consists of all elements that satisfy the predicate `p` and the second array stack consists of all elements that don't. The relative order of the elements in the resulting array stacks is the same as in the original array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

136. #### abstract def patch(from: Int, that: GenSeq[T], replaced: Int): ArrayStack[T]

     [use case] Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     [use case]

     Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original array stack

     returns

       a new array stack consisting of all elements of this array stack except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

137. #### def patch[B >: T, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     B

       the element type of the returned array stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original array stack

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new array stack consisting of all elements of this array stack except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike

138. #### def permutations: Iterator[ArrayStack[T]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this array stack.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

139. #### def pop(): T

     Pop the top element off the stack.

     Pop the top element off the stack.

     returns

       the element on top of the stack

140. #### def prefixLength(p: (T) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this array stack such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

141. #### def preserving[T](action: ⇒ T): T

     Evaluates the expression, preserving the contents of the stack so that any changes the evaluation makes to the stack contents will be undone after it completes.

     Evaluates the expression, preserving the contents of the stack so that any changes the evaluation makes to the stack contents will be undone after it completes.

     action

       The action to run.

142. #### abstract def product: T

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this array stack with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

143. #### def product[B >: T](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this array stack with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

144. #### def push(x: T): Unit

     Push an element onto the stack.

     Push an element onto the stack.

     x

       The element to push

145. #### def reduce[A1 >: T](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this array stack using the specified associative binary operator.

     Reduces the elements of this array stack using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the array stack is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this array stack is empty.

146. #### def reduceLeft[B >: T](op: (B, T) ⇒ B): B

     Definition Classes
       TraversableOnce

147. #### def reduceLeftOption[B >: T](op: (B, T) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this array stack, going left to right.

     Optionally applies a binary operator to all elements of this array stack, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this array stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

148. #### def reduceOption[A1 >: T](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this array stack, if any, using the specified associative binary operator.

     Reduces the elements of this array stack, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

149. #### def reduceRight[B >: T](op: (T, B) ⇒ B): B

     Applies a binary operator to all elements of this array stack, going right to left.

     Applies a binary operator to all elements of this array stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this array stack, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this array stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this array stack is empty.

150. #### def reduceRightOption[B >: T](op: (T, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this array stack, going right to left.

     Optionally applies a binary operator to all elements of this array stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this array stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

151. #### def reduceWith(f: (T, T) ⇒ T): Unit

     Repeatedly combine the top elements of the stack until the stack contains only one element.

     Repeatedly combine the top elements of the stack until the stack contains only one element.

     f

       The function to apply repeatedly to topmost elements.

152. #### def repr: ArrayStack[T]

     The collection of type array stack underlying this `TraversableLike` object.

     The collection of type array stack underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

153. #### def result(): ArrayStack[T]

     Produces a collection from the added elements.

     Produces a collection from the added elements. The builder's contents are undefined after this operation.

     returns

       a collection containing the elements added to this builder.

     Definition Classes
       ArrayStack → Builder

154. #### def reverse: ArrayStack[T]

     Returns new array stack wih elements in reversed order.

     Returns new array stack wih elements in reversed order.

     returns

       A new array stack with all elements of this array stack in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

155. #### def reverseIterator: Iterator[T]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this array stack in reversed order

     Definition Classes
       SeqLike

156. #### abstract def reverseMap[B](f: (T) ⇒ B): ArrayStack[B]

     [use case] Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this array stack and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

157. #### def reverseMap[B, That](f: (T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this array stack and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

158. #### def reversed: List[T]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

159. #### abstract def sameElements(that: GenIterable[T]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this array stack.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this array stack.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

160. #### def sameElements[B >: T](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this array stack.

     Checks if the other iterable collection contains the same elements in the same order as this array stack.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

161. #### def scan[B >: T, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[ArrayStack[T], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new array stack containing the prefix scan of the elements in this array stack

     Definition Classes
       TraversableLike → GenTraversableLike

162. #### def scanLeft[B, That](z: B)(op: (B, T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

163. #### def scanRight[B, That](z: B)(op: (T, B) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

164. #### def segmentLength(p: (T) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this array stack starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

165. #### def seq: Seq[T]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

166. #### def size: Int

     The size of this array stack, equivalent to `length`.

     The size of this array stack, equivalent to `length`.

     returns

       the number of elements in this array stack.

     Definition Classes
       ArrayStack → SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

167. #### def sizeHint(coll: scala.collection.TraversableLike[_, _], delta: Int = 0): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     delta

       a correction to add to the `coll.size` to produce the size hint.

     Definition Classes
       Builder

168. #### def sizeHint(size: Int): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called.

     Gives a hint how many elements are expected to be added when the next `result` is called. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     Definition Classes
       Builder

169. #### def sizeHintBounded(size: Int, boundingColl: scala.collection.TraversableLike[_, _]): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection.

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     boundingColl

       the bounding collection. If it is an IndexedSeqLike, then sizes larger than collection's size are reduced.

     Definition Classes
       Builder

170. #### def slice(from: Int, until: Int): ArrayStack[T]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this array stack.

     until

       the highest index to EXCLUDE from this array stack.

     returns

       a array stack containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this array stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

171. #### def sliding[B >: T](size: Int, step: Int): Iterator[ArrayStack[T]]

     Definition Classes
       IterableLike

172. #### def sliding[B >: T](size: Int): Iterator[ArrayStack[T]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing array stacks of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

173. #### def sortBy[B](f: (T) ⇒ B)(implicit ord: Ordering[B]): ArrayStack[T]

     Sorts this ArrayStack according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this ArrayStack according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a array stack consisting of the elements of this array stack sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

174. #### def sortWith(lt: (T, T) ⇒ Boolean): ArrayStack[T]

     Sorts this array stack according to a comparison function.

     Sorts this array stack according to a comparison function.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a array stack consisting of the elements of this array stack sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

175. #### def sorted[B >: T](implicit ord: Ordering[B]): ArrayStack[T]

     Sorts this array stack according to an Ordering.

     Sorts this array stack according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a array stack consisting of the elements of this array stack sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

176. #### def span(p: (T) ⇒ Boolean): (ArrayStack[T], ArrayStack[T])

     Splits this array stack into a prefix/suffix pair according to a predicate.

     Splits this array stack into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this array stack whose elements all satisfy `p`, and the rest of this array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

177. #### def splitAt(n: Int): (ArrayStack[T], ArrayStack[T])

     Splits this array stack into two at a given position.

     Splits this array stack into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of array stacks consisting of the first `n` elements of this array stack, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

178. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this array stack contains the given sequence at a given index.

     Tests whether this array stack contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this array stack at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

179. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this array stack starts with the given sequence.

     Tests whether this array stack starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

180. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this array stack. By default the string prefix is the simple name of the collection class array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

181. #### abstract def sum: T

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this array stack with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

182. #### def sum[B >: T](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this array stack with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

183. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

184. #### def tail: ArrayStack[T]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a array stack consisting of all elements of this array stack except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the array stack is empty.

185. #### def tails: Iterator[ArrayStack[T]]

     Iterates over the tails of this array stack.

     Iterates over the tails of this array stack. The first value will be this array stack and the final one will be an empty array stack, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this array stack

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

186. #### def take(n: Int): ArrayStack[T]

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this array stack.

     returns

       a array stack consisting only of the first `n` elements of this array stack, or else the whole array stack, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

187. #### def takeRight(n: Int): ArrayStack[T]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a array stack consisting only of the last `n` elements of this array stack, or else the whole array stack, if it has less than `n` elements.

     Definition Classes
       IterableLike

188. #### def takeWhile(p: (T) ⇒ Boolean): ArrayStack[T]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this array stack whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

189. #### def thisCollection: Seq[T]

     The underlying collection seen as an instance of `ArrayStack`.

     The underlying collection seen as an instance of `ArrayStack`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

190. #### abstract def toArray: Array[T]

     [use case] Converts this array stack to an array.

     [use case]

     Converts this array stack to an array.

     returns

       an array containing all elements of this array stack.

     Definition Classes
       GenTraversableOnce

191. #### def toArray[B >: T](implicit arg0: ClassManifest[B]): Array[B]

     Converts this array stack to an array.

     Converts this array stack to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

192. #### def toBuffer[B >: T]: Buffer[B]

     Converts this array stack to a mutable buffer.

     Converts this array stack to a mutable buffer.

     returns

       a buffer containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

193. #### def toCollection(repr: ArrayStack[T]): Seq[T]

     A conversion from collections of type `Repr` to `ArrayStack` objects.

     A conversion from collections of type `Repr` to `ArrayStack` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

194. #### def toIndexedSeq[B >: T]: IndexedSeq[B]

     Converts this array stack to an indexed sequence.

     Converts this array stack to an indexed sequence.

     returns

       an indexed sequence containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

195. #### def toIterable: Iterable[T]

     Converts this array stack to an iterable collection.

     Converts this array stack to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this array stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

196. #### def toIterator: Iterator[T]

     Returns an Iterator over the elements in this array stack.

     Returns an Iterator over the elements in this array stack. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this array stack.

     Definition Classes
       TraversableLike → GenTraversableOnce

197. #### def toList: List[T]

     Converts this array stack to a list.

     Converts this array stack to a list.

     returns

       a list containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

198. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this array stack to a map.

     [use case]

     Converts this array stack to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this array stack.

     Definition Classes
       GenTraversableOnce

199. #### def toMap[T, U](implicit ev: <:<[T, (T, U)]): Map[T, U]

     Converts this array stack to a map.

     Converts this array stack to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

200. #### def toSeq: Seq[T]

     Converts this array stack to a sequence.

     Converts this array stack to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this array stack.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

201. #### def toSet[B >: T]: Set[B]

     Converts this array stack to a set.

     Converts this array stack to a set.

     returns

       a set containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

202. #### def toStream: Stream[T]

     Converts this array stack to a stream.

     Converts this array stack to a stream.

     returns

       a stream containing all elements of this array stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

203. #### def toString(): String

     Converts this array stack to a string.

     Converts this array stack to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this array stack, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → AnyRef → Any

204. #### def toTraversable: Traversable[T]

     Converts this array stack to an unspecified Traversable.

     Converts this array stack to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this array stack.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

205. #### def top: T

     View the top element of the stack.

     View the top element of the stack.

     Does not remove the element on the top. If the stack is empty, an exception is thrown.

     returns

       the element on top of the stack.

206. #### def transform(f: (T) ⇒ T): ArrayStack.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

207. #### def transpose[B](implicit asTraversable: (T) ⇒ GenTraversableOnce[B]): ArrayStack[ArrayStack[B]]

     Transposes this array stack of traversable collections into a array stack of array stacks.

     Transposes this array stack of traversable collections into a array stack of array stacks.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this array stack is a `Traversable`.

     returns

       a two-dimensional array stack of array stacks which has as nth row the nth column of this array stack.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this array stack are not of the same size.

208. #### abstract def union(that: Seq[T]): ArrayStack[T]

     [use case] Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

     Definition Classes
       SeqLike

209. #### def union[B >: T, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     B

       the element type of the returned array stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike

210. #### def unzip[A1, A2](implicit asPair: (T) ⇒ (A1, A2)): (ArrayStack[A1], ArrayStack[A2])

     Converts this array stack of pairs into two collections of the first and second half of each pair.

     Converts this array stack of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this array stack is a pair.

     returns

       a pair array stacks, containing the first, respectively second half of each element pair of this array stack.

     Definition Classes
       GenericTraversableTemplate

211. #### def unzip3[A1, A2, A3](implicit asTriple: (T) ⇒ (A1, A2, A3)): (ArrayStack[A1], ArrayStack[A2], ArrayStack[A3])

     Converts this array stack of triples into three collections of the first, second, and third element of each triple.

     Converts this array stack of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this array stack is a triple.

     returns

       a triple array stacks, containing the first, second, respectively third member of each element triple of this array stack.

     Definition Classes
       GenericTraversableTemplate

212. #### def update(n: Int, newelem: T): Unit

     Replace element at index `n` with the new element `newelem`.

     Replace element at index `n` with the new element `newelem`.

     This is a constant time operation.

     n

       the index of the element to replace.

     newelem

       the new element.

     Definition Classes
       ArrayStack → SeqLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index is not valid

213. #### abstract def updated(index: Int, elem: T): ArrayStack[T]

     [use case] A copy of this array stack with one single replaced element.

     [use case]

     A copy of this array stack with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new array stack`which is a copy of this array stack with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

214. #### def updated[B >: T, That](index: Int, elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     A copy of this array stack with one single replaced element.

     A copy of this array stack with one single replaced element.

     B

       the element type of the returned array stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new array stack`which is a copy of this array stack with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqLike → GenSeqLike

215. #### def view(from: Int, until: Int): SeqView[T, ArrayStack[T]]

     Creates a non-strict view of a slice of this array stack.

     Creates a non-strict view of a slice of this array stack.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current array stack, whereas `slice` produces a new array stack.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this array stack, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

216. #### def view: SeqView[T, ArrayStack[T]]

     Creates a non-strict view of this array stack.

     Creates a non-strict view of this array stack.

     returns

       a non-strict view of this array stack.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

217. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

218. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

219. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

220. #### def withFilter(p: (T) ⇒ Boolean): FilterMonadic[T, ArrayStack[T]]

     Creates a non-strict filter of this array stack.

     Creates a non-strict filter of this array stack.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this array stack which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

221. #### abstract def zip[B](that: GenIterable[B]): ArrayStack[(T, B)]

     [use case] Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the minimum of the lengths of this array stack and `that`.

     Definition Classes
       GenIterableLike

222. #### def zip[A1 >: T, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[ArrayStack[T], (A1, B), That]): That

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the minimum of the lengths of this array stack and `that`.

     Definition Classes
       IterableLike → GenIterableLike

223. #### abstract def zipAll[B](that: Iterable[B], thisElem: T, thatElem: B): ArrayStack[(T, B)]

     [use case] Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this array stack is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this array stack.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the maximum of the lengths of this array stack and `that`. If this array stack is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this array stack, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

224. #### def zipAll[B, A1 >: T, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[ArrayStack[T], (A1, B), That]): That

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this array stack is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this array stack.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the maximum of the lengths of this array stack and `that`. If this array stack is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this array stack, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

225. #### abstract def zipWithIndex: ArrayStack[(T, Int)]

     [use case] Zips this array stack with its indices.

     [use case]

     Zips this array stack with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this array stack paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

226. #### def zipWithIndex[A1 >: T, That](implicit bf: CanBuildFrom[ArrayStack[T], (A1, Int), That]): That

     Zips this array stack with its indices.

     Zips this array stack with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this array stack paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def elements: Iterator[T]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

2. #### def equalsWith[B](that: Seq[B])(f: (T, B) ⇒ Boolean): Boolean

   Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this array stack and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

3. #### def findIndexOf(p: (T) ⇒ Boolean): Int

   Returns index of the first element satisfying a predicate, or `-1`.

   Returns index of the first element satisfying a predicate, or `-1`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use indexWhere(p) instead.

4. #### def findLastIndexOf(p: (T) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

5. #### def first: T

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

6. #### def firstOption: Option[T]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

7. #### def peek: T

   View the top element of the stack.

   View the top element of the stack.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use top instead

8. #### def projection: SeqView[T, ArrayStack[T]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     SeqLike → IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

9. #### def reversedElements: Iterator[T]

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from Serializable

### Inherited from Builder[T, ArrayStack[T]]

### Inherited from Growable[T]

### Inherited from Seq[T]

### Inherited from SeqLike[T, ArrayStack[T]]

### Inherited from Cloneable[ArrayStack[T]]

### Inherited from Seq[T]

### Inherited from SeqLike[T, ArrayStack[T]]

### Inherited from GenSeq[T]

### Inherited from GenSeqLike[T, ArrayStack[T]]

### Inherited from PartialFunction[Int, T]

### Inherited from (Int) ⇒ T

### Inherited from Iterable[T]

### Inherited from IterableLike[T, ArrayStack[T]]

### Inherited from Equals

### Inherited from GenIterable[T]

### Inherited from GenIterableLike[T, ArrayStack[T]]

### Inherited from Traversable[T]

### Inherited from Mutable

### Inherited from Traversable[T]

### Inherited from GenTraversable[T]

### Inherited from GenericTraversableTemplate[T, ArrayStack]

### Inherited from TraversableLike[T, ArrayStack[T]]

### Inherited from GenTraversableLike[T, ArrayStack[T]]

### Inherited from Parallelizable[T, ParSeq[T]]

### Inherited from TraversableOnce[T]

### Inherited from GenTraversableOnce[T]

### Inherited from FilterMonadic[T, ArrayStack[T]]

### Inherited from HasNewBuilder[T, ArrayStack[T]]

### Inherited from AnyRef

### Inherited from Any